------------------------------------------------------------------------------------------------------------------------------------------------
--"viewportSnaper"
--"produced by apras();"
--"http://www.apras.net/"
--
--
--memo
--J܂łǁǍ܂AOV[mFƂƂɕ֗
--ANeBur[|[g(p[XyNeBu)̈ʒuƕۑc[łB
--t@Ĉɏۑł悤ɂA֗ȁH
--
--
--
--How to use
-- 1, ANeBur[|[gp[XyNeBu̎ɁA"get viewport"{^ɂăXgɒǉ܂B
-- 2, o^Ă鍀ڂIāA"set viewport"{^ɂăANeBur[|[g̈ʒuƕL^ꂽ̂ւƕύX܂B
-- 3, o^ꂽXg̍ڎg_uNbN鎖łALƓ삪s܂B
-- 4, Xg̍ڂI()ENbNɂďo郁j[ɂčڂ폜ł܂B
-- 5, ENbNj[́A"create camera"ɂēo^Ă鍀ڂ̈ʒuƕɃt[J쐬܂B
-- 6, "save"{^ɂăXgۑ邱Ƃo܂B
-- 7, "load"{^ɂďLƂŕۑt@CJƂ\łB
-- 8, ȌAVV[Jꍇ 6 ŕۑt@C"utility"t[^"load ini file"ǂݍŎgpł܂
--
--
--History
--2008/01/10 1.10	Added support for 2008
--2007/09/11 1.00	First release
--
--
--ɂ񂵂ČlIɎĝ́BĔzzƂ́~B
--zƂ̓[Rgł肢܂B
------------------------------------------------------------------------------------------------------------------------------------------------
--
--
--
------------------------------------------------------------------------------------------------------------------------------------------------
try
(
	gc light:true
	cui.UnRegisterDialogBar viewportSnaper 
	destroyDialog viewportSnaper 
)
catch
(
)
------------------------------------------------------------------------
--
--
--
------------------------------------------------------------------------
--`
mineVersion = 1.10
viewInfoCollection = #()
selectedIndexCollection = #()
--
--[AEg
viewportSnaper			= undefined
--
--֐
selectCollector	 		= undefined
reSetList					= undefined
unique						= undefined
getViewPort				= undefined
setViewPort				= undefined
createCamera			= undefined
upCheck					= undefined
saveView					= undefined
loadView					= undefined
editLabel					= undefined
emptyCheck				= undefined
whenCreateCameraPressed	= undefined
whenSnapPressed		= undefined
whenDeletePressed	= undefined
--
--r[|[g\̒`
struct viewInfo
(
	index,
	label,
	TM,
	FOV
)
------------------------------------------------------------------------
--
--
--֐
------------------------------------------------------------------------
--
-- IڎW֐
fn selectCollector =
(
	local selectedIndexCollection = #()
	local selectedCount = (viewportSnaper.list1.SelectedIndices.Count) - 1
	for i = 0 to selectedCount do
	(
		local l_index = (viewportSnaper.list1.SelectedIndices.item i) + 1
		append selectedIndexCollection l_index
	)
	return selectedIndexCollection
)
--
-- XgXV֐
fn reSetList =
(
	--
	local labelCollection = #()
	for item in viewInfoCollection do
	(
		append labelCollection (dotNetObject "System.Windows.Forms.ListViewItem" item.label)
	)
	viewportSnaper.list1.Items.Clear()
	viewportSnaper.list1.Items.AddRange labelCollection
	--
)
--
-- j[Nio[֐
fn unique =
(
	local l_num = random 1 10000
	for item in viewInfoCollection do
	(
		if (item.index == l_num) then
			unique()
		else
			return l_num
	)
	return l_num
)
--
-- r[|[gW֐
fn getViewPort =
(
	if (viewport.getType() == #view_persp_user) then
	(
		local l_index = unique()
		if (viewportSnaper.edit1.text == "") then
			local l_label = "label" + (l_index as string)
		else
			local l_label = edit1.text

		local l_viewPort = viewInfo l_index l_label (viewport.getTM()) (viewport.GetFOV())
		--
		append viewInfoCollection l_viewPort
		reSetList()
	)
	else
	(
		messageBox "not perspective view"
	)
)
--
-- r[|[gKp֐
fn setViewPort =
(
	if (viewport.getType() == #view_persp_user) then
	(
		if ((viewportSnaper.list1.SelectedIndices.Count < 2) and (viewportSnaper.list1.SelectedIndices.Count > 0)) then
		(
			local l_index = (viewportSnaper.list1.SelectedIndices.item 0) + 1
			local l_TM = viewInfoCollection[l_index].TM
			local l_FOV = viewInfoCollection[l_index].FOV
			viewport.setTM l_TM
			try
			(
				viewport.SetFOV l_FOV
			)
			catch
			(
			)
		)else 
		(
			messageBox "select One item."
		)
	)
	else
	(
		messageBox "not perspective view"
	)
		
)
--
-- J֐
fn createCamera =
(
	local l_select = selectCollector()
	--
	for item in l_select do
	(
		local cameraName = viewInfoCollection[item].label
		local cameraTM = Inverse(viewInfoCollection[item].TM)
		local FOV =  viewInfoCollection[item].FOV
		Freecamera name:cameraName fov:FOV targetDistance:160 nearclip:1 farclip:1000 nearrange:0 farrange:1000 mpassEnabled:off mpassRenderPerPass:off transform:(cameraTM) isSelected:off
	)
)
--
-- Abvf[gmF֐
fn upCheck =
(
	local url	= "http://www.apras.net/contents/data_dev/script/index.xml"
	try
	(
		dotnet.loadAssembly "system.xml.dll"
		--local url = "c:\\index.xml"
		local doc = dotNetObject "System.Xml.XmlDocument"
		doc.load url
		--
		local xpath = "/softInfo/viewportSnaper/latestVer"
		local root = doc.DocumentElement
		local nodeList = root.SelectNodes xpath
		local element = nodeList.Item 0
		local latastVer = element.GetAttribute "ver"
		if ((latastVer as float) > mineVersion) then
		(
			if (queryBox ("this is old version.\nupdate now ?") title:"update check !") then
			(
				ShellLaunch "http://www.apras.net/" ""
			)else(
			)
		)else
		(
			messageBox ("this is latest version.") title:"update check !"
		)
		--
	)
	catch
	(
		messageBox ("disconnect network.") title:"error"
	)
)
--
-- Z[u֐
fn saveView =
(
	if (viewInfoCollection.count > 0) then
	(
		local output_name = getSaveFileName caption:"viewportSnaper save file" types:"Text (*.txt)|*.txt|All Files (*.*)|*.*|"
		if (output_name != undefined) then
		(
			output_file = createfile output_name
			for item in viewInfoCollection  do
			(
				format "%;" (item as string) to:output_file
			)
			close output_file
			messageBox "complete !!"
		)else
		(
			
		)
	)else
	(
		messageBox "list is empty!!"
	)
)
--
-- [h֐
fn loadView =
(
	local in_name = getOpenFileName caption:"viewportSnaper load file" types:"Text (*.txt)|*.txt|All Files (*.*)|*.*|"
	if (in_name != undefined) then
	(
		in_file = openFile in_name
		if in_file != undefined then
		(
			--local boneArray = #()
			case (yesNoCancelBox "List is emptied.") of
			(
				#yes :
				(
					viewInfoCollection = #()
					while not eof in_file do
					(
						local l_viewInfoString = readDelimitedString in_file ";"
						local l_viewInfo = execute l_viewInfoString
						append viewInfoCollection l_viewInfo 
					)
					close in_file
					reSetList()
				)
				#no :
				(
					messageBox "It adds to this list."
					while not eof in_file do
					(
						local l_viewInfoString = readDelimitedString in_file ";"
						local l_viewInfo = execute l_viewInfoString
						append viewInfoCollection l_viewInfo 
					)
					close in_file
					reSetList()
				)
				#cancel :
				(
				)
				default :
				(
				)
			)
		)else
		(
			messageBox "file open error!!"
		)
	)
)
--
-- xҏW֐
fn editLabel e =
(
	if (not e.CancelEdit) then
	(
		if ((e.Item != undefined) and (e.Label != undefined)) then
		(
			viewInfoCollection[(e.Item + 1)].label = e.Label
		)
	)
)
--
-- Xg`FbN֐
fn emptyCheck =
(
	if (viewInfoCollection.count == 0) then
	(
		viewportSnaper.newcontitem1.Enabled = false
		viewportSnaper.newcontitem2.Enabled = false
		viewportSnaper.newcontitem3.Enabled = false
	)else
	(
		viewportSnaper.newcontitem1.Enabled = true
		viewportSnaper.newcontitem2.Enabled = true
		viewportSnaper.newcontitem3.Enabled = true
	)
)
fn whenCreateCameraPressed e =
(
	createCamera();
)
fn whenSnapPressed e =
(
	setViewPort()
)
fn whenDeletePressed e =
(
	local l_select = selectCollector()
	--
	local l_viewInfoCollection = #()
	local viewInfoCollectionCount = viewInfoCollection.count
	for i = 1 to viewInfoCollectionCount do
	(
		if ((findItem l_select i) == 0) then
		(
			append l_viewInfoCollection viewInfoCollection[i]
		)
	)
	viewInfoCollection = l_viewInfoCollection
	--
	reSetList()
)
------------------------------------------------------------------------
--
--
--[AEg`
------------------------------------------------------------------------
rollout viewportSnaper "viewportSnaper"
(
	------------------------------------------------------------------------
	--
	--
	-- [Jϐ
	------------------------------------------------------------------------
	local cntmenu		= undefined
	local newcontitem1	= undefined
	local newcontitem2	= undefined
	local newcontitem3	= undefined
	
	------------------------------------------------------------------------
	--
	--
	-- C^[tF[X`
	------------------------------------------------------------------------
	dotNetControl list1 "System.Windows.Forms.ListView" width:120 height:310  pos:[9, 8]
	edittext edit1 "label :" fieldWidth:120 labelOnTop:true pos:[10, 325]
	button bt1 "get viewport" width:120 height:18 pos:[10,365]
	button bt2 "set viewport" width:120 height:18 pos:[10,385]
	--
	button bt4 "save" width:60 height:18 pos:[10,405]
	button bt5 "load" width:60 height:18 pos:[70,405]
	--
	button bt3 "update check" width:120 height:18 pos:[10, 425]
	--
	label lb0 "--------------------" 	pos:[10,445] 
	label lb1 ": :  viewportSnaper"	pos:[15,455]
	label lb2 ": :  1.1"			pos:[15,470]
	label lb3 ": :  01/10/2008"		pos:[15,485]
	label lb4 ": : "				pos:[15,500]
	hyperLink hl1 "www.apras.net" pos:[30,500] address:"http://www.apras.net/" color:orange hoverColor:orange visitedColor:orange
	label lb5 "--------------------" 	pos:[10,510] 
	
	------------------------------------------------------------------------
	--
	--
	-- [J֐
	------------------------------------------------------------------------
	--
	-- Xg֐
	fn initListView lv =
	(
		--
		cntmenu = dotNetObject "System.Windows.Forms.ContextMenuStrip"
		--
		newcontitem1 = dotNetObject "System.Windows.Forms.ToolStripMenuItem"
		newcontitem1.Text = "&set viewport"
		newcontitem2 = dotNetObject "System.Windows.Forms.ToolStripMenuItem"
		newcontitem2.Text = "&delete"
		newcontitem3 = dotNetObject "System.Windows.Forms.ToolStripMenuItem"
		newcontitem3.Text = "&create camera"
		--
		dotNet.addEventHandler newcontitem1 "MouseDown" whenSnapPressed
		dotNet.addEventHandler newcontitem2 "MouseDown" whenDeletePressed
		dotNet.addEventHandler newcontitem3 "MouseDown" whenCreateCameraPressed
		--
		cntmenu.Items.Add newcontitem1
		cntmenu.Items.Add newcontitem3
		cntmenu.Items.Add newcontitem2
		--
		lv.ContextMenuStrip = cntmenu
		--
		lv.gridLines = true
		lv.LabelEdit = true;
		lv.View = (dotNetClass "System.Windows.Forms.View").Details
		lv.fullRowSelect = true
		layout_def = #("label")
		for i in layout_def do
			lv.Columns.add i 110
	) 
	------------------------------------------------------------------------
	--
	--
	-- Cxgnh`
	------------------------------------------------------------------------
	on viewportSnaper open do ( initListView list1 )
	--
	on bt1 pressed do ( getViewPort() )
	--
	on bt2 pressed do ( setViewPort() )
	--
	on bt3 pressed do ( upCheck() )
	--
	on bt4 pressed do ( saveView() )
	--
	on bt5 pressed do ( loadView() )
	--
	on list1 MouseDown e do ( emptyCheck() )
	--
	on list1 DoubleClick e do ( setViewPort() )
	--
	on list1 AfterLabelEdit e do ( editLabel e ) 
)
------------------------------------------------------------------------
createDialog viewportSnaper 140 560 --menu:rc_Main
--
--PopupMenu mainRoItemRCmenu
--
cui.RegisterDialogBar viewportSnaper style:#(#cui_dock_right , #cui_floatable, #cui_handles) 
